(eval-when-compile (require 'cl))
(require 'eieio)
(require 'eieio-base)

(defclass bc-test-db (eieio-persistent)
  ((data :initarg :data
	 :initform (make-hash-table :size 10000 :rehash-size 2.0 :test 'equal)
		     :type t)))

;; ----------------------
;; Emacs23 version:

;; older EIEIO bug
;; (eval-when-compile (setq filename nil))

;; (defclass bc-test-db (eieio-persistent)
;;   ((data :initarg :data
;; 	:type t)))

;; (defmethod initialize-instance :after ((this bc-test-db) slots)
;;   "Set value of data slot of THIS after initialization."
;;   (with-slots (data) this
;;     (setq data (make-hash-table :size 10000 :rehash-size 2.0 :test 'equal))))
;; -----------------------


(defmethod bc-test-get-mapcar ((db bc-test-db) keys)
  (let ((data (oref db :data)))
    (delq nil
	(mapcar
	 (lambda (k)
	   (when (gethash k data)
	     (list k (gethash k data))))
	 keys))))

(defmethod bc-test-get-loop ((db bc-test-db) keys)
  (let ((data (oref db :data)))
    (loop for k in keys
          when (gethash k data)
          collect (list k (gethash k data)))))

(defvar bc-test-mydb (bc-test-db "mydb"))

(defun bc-test ()
  (interactive)
  (let ((data (oref bc-test-mydb :data)))
    (dotimes (i 100)
      (puthash (number-to-string i) (format "foo %d" i) data)))
  (message "Method with mapcar: %s"
	   (prin1-to-string (bc-test-get-mapcar bc-test-mydb '("20" "30" "40"))))
  (message "Method with loop: %s"
	   (prin1-to-string (bc-test-get-loop bc-test-mydb '("20" "30" "40"))))
  )
